package org.netkernel.layer0.boot;

import java.net.URI;

import org.netkernel.container.IKernel;

public interface IModuleFactory
{
	/** Attempt to build a module for the given source URI 
	 * @param aModuleURI the source for the module
	 * @param aKernel a reference to the kernel the module will be deployed to
	 * @return a module or null if the module isn't suitable for this factory
	 * @throws Exception thrown if there is a problem creating the module once it matches as being suitable
	 *  for this factory
	 */
	IModule buildModule(URI aModuleURI, IKernel aKernel) throws Exception;
}
