package org.netkernel.layer0.meta;

import org.netkernel.urii.IEndpoint;
import org.netkernel.urii.IMetaRepresentation;

/** Metadata interface for physical endpoints
 * @author tab
 */
public interface IPhysicalEndpointMeta extends IMetaRepresentation
{
	public static final IPhysicalEndpointFieldMeta[] NO_ADDITIONAL_FIELDS_META = new IPhysicalEndpointFieldMeta[0];
	
	/** Return the implementing class of the endpoint
	 * @return
	 */
	Class<IEndpoint> getImplementation();
	
	/** Return meta data about the state fields.
	 * @return
	 */
	IPhysicalEndpointFieldMeta[] getAdditionalFieldsMeta();
	
	/** Set one of the state fields
	 * @param aKey the name of the state field to set
	 * @param aRepresentation the value that the state should be set to
	 * @throws IllegalArgumentException throw if the field cannot be set or another problem updating the field occurs
	 */
	void setState(String aKey, Object aValue) throws IllegalArgumentException;	
}