package org.netkernel.layer0.meta.impl;

import org.netkernel.request.IRequestResponseFields;
import org.netkernel.request.impl.RequestResponseFieldsImpl;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.IMetaRepresentation;

public class LightMetaRepresentationImpl implements IMetaRepresentation
{
	private final String mName;
	private final String mDescription;
	
	public LightMetaRepresentationImpl(String aName, String aDescription)
	{	mName=aName;
		mDescription=aDescription;
	}
	
	public String getName()
	{	return mName;
	}
	
	public String getDescription()
	{	return mDescription;
	}

	public IIdentifier getIcon()
	{	return null;
	}
	
	public IIdentifier getHumanReadableDocumentation()
	{	return null;
	}

	public IRequestResponseFields getAdditionalFields()
	{	return RequestResponseFieldsImpl.EMPTY;
	}
	
}